AI_DIR = "./AI/USER_AI/"
require (AI_DIR.."ai_comm.lua")

SAVEFILENAME = AI_DIR.."savedatb.ini"
MYIDFILENAME = AI_DIR.."mercid.ini"
FRIENDIDFILENAME = AI_DIR.."homid.ini"

SplashSkillRadius = 0

function ReadConfig_Merc()
	if set_table.MercSearchPriority ~= nil then
		AttackPriority = txt2table (set_table.MercSearchPriority)
	else
		AttackPriority={2,1,5,6,4}
	end

	followMasterTarget  = set_table.MercFollowMasterTarget or 0

--	AttackMotionCancel1 = set_table.MercAttackMotionCancel1 or 0
	AttackMotionCancel2 = set_table.MercAttackMotionCancel2 or 0
	AttackMotionCancel3 = set_table.MercAttackMotionCancel3 or 0
	set_table.MercAttackMotionCancel2SPBorder = set_table.MercAttackMotionCancel2SPBorder or 10
	AttackMotionCancel2SPBorder = GetV(V_MAXSP, MyID) * set_table.MercAttackMotionCancel2SPBorder * 0.01

	if AttackMotionCancel3 == 1 then
		MotionCancel2 = MotionCancel3
	end

	--     IDLE_ST
	if set_table.MercRoundCtrl == 1 then
		RoundCtrl = true
	else
		RoundCtrl = false
	end

	RoundType = set_table.MercRoundType or 9
	RoundRadius = set_table.MercRoundRadius or 1
	RoundMirror = set_table.MercRoundMirror or 0
	RoundHomHP = set_table.MercRoundHP or 90
	RoundHomSP = set_table.MercRoundSP or 100
	RoundStart = set_table.MercRoundStart or 4000
	RoundNext = set_table.MercRoundNext or 1300

	CalcRoundArray()

	if (set_table.MaxIdleTimeCtrl == 1 and set_table.MaxIdleTimeTarg == 2) then
		MaxIdleTimeCtrl = true
		set_table.MaxIdleTimeout = set_table.MaxIdleTimeout or 5
		MaxIdleTimeout = MaxIdleTimeout * 60000
	else
		MaxIdleTimeCtrl = false
		MaxIdleTimeout = 0
	end

	set_table.MercActiveModeMinHP = set_table.MercActiveModeMinHP or 90
	ActiveModeMinHP = GetV(V_MAXHP, MyID) * set_table.MercActiveModeMinHP * 0.01
	set_table.MercActiveModeMinSP = set_table.MercActiveModeMinSP or 0
	ActiveModeMinSP = GetV(V_MAXSP, MyID) * set_table.MercActiveModeMinSP * 0.01
	AttackRange = GetV(V_ATTACKRANGE,MyID)

	DebuffSkillRange = set_table.DebuffSkillRange or 9

	local type = GetV(V_MERTYPE,MyID)

	TraceAI ("")
	TraceAI ("Starting AI. Mercenary type is "..type)

	if (ARCHER01 == type) then
		AttackSkill = SKILL_DOUBLE
		AttackSkillMaxLevel = 2
		set_table.A1_DoubleStopSP = set_table.A1_DoubleStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A1_DoubleStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (ARCHER02 == type) then
		AttackSkill = SKILL_SHOWER
		AttackSkillMaxLevel = 2
		set_table.A2_ShowerStopSP = set_table.A2_ShowerStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A2_ShowerStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (ARCHER03 == type or ARCHER04 == type or ARCHER08 == type) then
		SetAttackSkill = function() end

		if (Cmd_MoveToSide[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[0] = 0
		end
		if (Cmd_MoveToSide[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[1] = 0
		end
		if (Cmd_AltRight[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[0] = 0
		end
		if (Cmd_AltRight[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[1] = 0
		end

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (ARCHER05 == type) then
		AttackSkill = SKILL_DOUBLE
		AttackSkillMaxLevel = 5
		set_table.A5_DoubleStopSP = set_table.A5_DoubleStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A5_DoubleStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (ARCHER06 == type) then
		AttackSkill = SKILL_DOUBLE
		AttackSkillMaxLevel = 7
		set_table.A6_DoubleStopSP = set_table.A6_DoubleStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A6_DoubleStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (ARCHER07 == type) then
		AttackSkill = SKILL_SHOWER
		AttackSkillMaxLevel = 10
		set_table.A7_ShowerStopSP = set_table.A7_ShowerStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A7_ShowerStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (ARCHER09 == type) then
		AttackSkill = SKILL_DOUBLE
		AttackSkillMaxLevel = 10
		set_table.A9_DoubleStopSP = set_table.A9_DoubleStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A9_DoubleStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (ARCHER10 == type) then
		SetAttackSkill = function() end

		if (Cmd_MoveToSide[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[0] = 0
		end
		if (Cmd_MoveToSide[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[1] = 0
		end
		if (Cmd_AltRight[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[0] = 0
		end
		if (Cmd_AltRight[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[1] = 0
		end

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (LANCER01 == type) then
		AttackSkill	= SKILL_PIERCE
		AttackSkillMaxLevel = 1
		set_table.M1_PierceStopSP = set_table.M1_PierceStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M1_PierceStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (LANCER02 == type) then
		AttackSkill	= SKILL_BRANDISH
		AttackSkillMaxLevel = 2
		set_table.M2_BrandishStopSP = set_table.M2_BrandishStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M2_BrandishStopSP * 0.01
		AttackSkillCount = set_table.M2_BrandishEnemy or 2
		CheckTargetsNum = CheckBrandishTargets_eAthena

		DebuffSkill = SKILL_LEXDIVINA
		DebuffSkillMaxLevel = 1
		set_table.M_LexDivinaStopSP = set_table.M_LexDivinaStopSP or 5
		DebuffSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M_LexDivinaStopSP * 0.01

		BoostSkillCheck = function() end

	elseif (LANCER03 == type) then
		AttackSkill	= SKILL_PIERCE
		AttackSkillMaxLevel = 2
		set_table.M3_PierceStopSP = set_table.M3_PierceStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M3_PierceStopSP * 0.01

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (LANCER04 == type) then
		AttackSkill	= SKILL_CRASH
		AttackSkillMaxLevel = 4
		set_table.M4_CrashStopSP = set_table.M4_CrashStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M4_CrashStopSP * 0.01

		BoostSkill	= SKILL_DEFENDING_AURA
		BoostSkillLevel = 1

		if set_table.M4_AuraType == 1 then
			BoostSkillTiming = 0
		elseif set_table.M4_AuraType == 2 then
			BoostSkillTiming = set_table.M4_AuraEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.M4_AuraStopSP  = set_table.M4_AuraStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M4_AuraStopSP * 0.01
     
		UseDebuffSkill = function() end

	elseif (LANCER05 == type) then
		AttackSkill	= SKILL_PIERCE
		AttackSkillMaxLevel = 5
		set_table.M5_PierceStopSP = set_table.M5_PierceStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M5_PierceStopSP * 0.01

		BoostSkill	= SKILL_AUTOGUARD
		BoostSkillLevel = 3

		if set_table.M5_GuardType == 1 then
			BoostSkillTiming = 0
		elseif set_table.M5_GuardType == 2 then
			BoostSkillTiming = set_table.M5_GuardEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.M5_GuardStopSP  = set_table.M5_GuardStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M5_GuardStopSP * 0.01

		UseDebuffSkill = function() end

	elseif (LANCER06 == type) then
		AttackSkill	= SKILL_BRANDISH
		AttackSkillMaxLevel = 5
		set_table.M6_BrandishStopSP = set_table.M6_BrandishStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M6_BrandishStopSP * 0.01
		AttackSkillCount = set_table.M6_BrandishEnemy or 2
		CheckTargetsNum = CheckBrandishTargets_eAthena

		BoostSkill	= SKILL_WEAPON_QUICKEN
		BoostSkillLevel = 1

		if set_table.M6_QuickenType == 1 then
			BoostSkillTiming = 0
		elseif set_table.M6_QuickenType == 2 then
			BoostSkillTiming = set_table.M6_QuickenEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.M6_QuickenStopSP  = set_table.M6_QuickenStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M6_QuickenStopSP * 0.01

		UseDebuffSkill = function() end

	elseif (LANCER07 == type) then
		SetAttackSkill = function() end

		if (Cmd_MoveToSide[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[0] = 0
		end
		if (Cmd_MoveToSide[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[1] = 0
		end
		if (Cmd_AltRight[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[0] = 0
		end
		if (Cmd_AltRight[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[1] = 0
		end

		BoostSkill	= SKILL_BERSERK
		BoostSkillLevel = 1

		if set_table.M7_BerserkType == 1 then
			BoostSkillTiming = 0
		elseif set_table.M7_BerserkType == 2 then
			BoostSkillTiming = set_table.M7_BerserkEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.M7_BerserkStopSP  = set_table.M7_BerserkStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M7_BerserkStopSP * 0.01

		UseDebuffSkill = function() end

	elseif (LANCER08 == type) then
		AttackSkill	= SKILL_PIERCE
		AttackSkillMaxLevel = 10
		set_table.M8_PierceStopSP = set_table.M8_PierceStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M8_PierceStopSP * 0.01

		DebuffSkill = SKILL_PROVOKE
		DebuffSkillMaxLevel = 5
		set_table.M8_ProvokeStopSP = set_table.M8_ProvokeStopSP or 5
		DebuffSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M8_ProvokeStopSP * 0.01

		BoostSkillCheck = function() end

	elseif (LANCER09 == type) then
		AttackSkill	= SKILL_BRANDISH
		AttackSkillMaxLevel = 10
		set_table.M9_BrandishStopSP = set_table.M9_BrandishStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M9_BrandishStopSP * 0.01
		AttackSkillCount = set_table.M9_BrandishEnemy or 2
		CheckTargetsNum = CheckBrandishTargets_eAthena

		if set_table.M9_BoostSkill == 1 then
			BoostSkill	= SKILL_AUTOGUARD
			BoostSkillLevel = 7

			if set_table.M9_GuardType == 1 then
				BoostSkillTiming = 0
			elseif set_table.M9_GuardType == 2 then
				BoostSkillTiming = set_table.M9_GuardEnemy or 1
			else
				BoostSkillTiming = -1
			end
			set_table.M9_GuardStopSP  = set_table.M9_GuardStopSP or 5
			BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M9_GuardStopSP * 0.01
		else
			BoostSkill	= SKILL_DEFENDING_AURA
			BoostSkillLevel = 3

			if set_table.M9_AuraType == 1 then
				BoostSkillTiming = 0
			elseif set_table.M9_AuraType == 2 then
				BoostSkillTiming = set_table.M9_AuraEnemy or 1
			else
				BoostSkillTiming = -1
			end
			set_table.M9_AuraStopSP  = set_table.M9_AuraStopSP or 5
			BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.M9_AuraStopSP * 0.01
		end

		UseDebuffSkill = function() end

	elseif (type == LANCER10) then
		SetAttackSkill = function() end

		if (Cmd_MoveToSide[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[0] = 0
		end
		if (Cmd_MoveToSide[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[1] = 0
		end
		if (Cmd_AltRight[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[0] = 0
		end
		if (Cmd_AltRight[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[1] = 0
		end

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (SWORDMAN01 == type) then
		AttackSkill	= SKILL_BASH
		AttackSkillMaxLevel = 1
		set_table.S1_BashStopSP = set_table.S1_BashStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S1_BashStopSP * 0.01

		DebuffSkill = SKILL_DECAGI
		DebuffSkillMaxLevel = 1
		set_table.S1_DecAGIStopSP = set_table.S1_DecAGIStopSP or 5
		DebuffSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S1_DecAGIStopSP * 0.01
		
		BoostSkillCheck = function() end

	elseif (SWORDMAN02 == type) then
		AttackSkill	= SKILL_MAGNUM
		AttackSkillMaxLevel = 3
		set_table.S2_MagnumStopSP = set_table.S2_MagnumStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S2_MagnumStopSP * 0.01
		AttackSkillCount = set_table.S2_MagnumEnemy or 2
		SplashSkillRadius = 2
		CheckTargetsNum = CheckSplashTargets

		DebuffSkill = SKILL_PROVOKE
		DebuffSkillMaxLevel = 5
		set_table.S_ProvokeStopSP = set_table.S_ProvokeStopSP or 5
		DebuffSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S_ProvokeStopSP * 0.01

		BoostSkillCheck = function() end

	elseif (SWORDMAN03 == type) then
		SetAttackSkill = function() end

		BoostSkill	= SKILL_WEAPON_QUICKEN
		BoostSkillLevel = 1

		if set_table.S3_QuickenType == 1 then
			BoostSkillTiming = 0
		elseif set_table.S3_QuickenType == 2 then
			BoostSkillTiming = set_table.S3_QuickenEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.S3_QuickenStopSP  = set_table.S3_QuickenStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S3_QuickenStopSP * 0.01

		UseDebuffSkill = function() end

	elseif (SWORDMAN04 == type) then
		if set_table.S4_AttackSkill == 1 then
			AttackSkill	= SKILL_MAGNUM
			AttackSkillMaxLevel = 5
			set_table.S4_MagnumStopSP = set_table.S4_MagnumStopSP or 5
			AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S4_MagnumStopSP * 0.01
			AttackSkillCount = set_table.S4_MagnumEnemy or 1
			SplashSkillRadius = 2
			CheckTargetsNum = CheckSplashTargets
		else
			AttackSkill	= SKILL_CRASH
			AttackSkillMaxLevel = 1
			set_table.S4_CrashStopSP = set_table.S4_CrashStopSP or 5
			AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S4_CrashStopSP * 0.01
		end

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (SWORDMAN05 == type) then
		if set_table.S5_AttackSkill == 1 then
			AttackSkill	= SKILL_BASH
			AttackSkillMaxLevel = 5
			set_table.S5_BashStopSP = set_table.S5_BashStopSP or 5
			AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S5_BashStopSP * 0.01
		else
			AttackSkill	= SKILL_CRASH
			AttackSkillMaxLevel = 4
			set_table.S5_CrashStopSP = set_table.S5_CrashStopSP or 5
			AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S5_CrashStopSP * 0.01
		end

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end

	elseif (SWORDMAN06 == type) then
		SetAttackSkill = function() end

		BoostSkill	= SKILL_WEAPON_QUICKEN
		BoostSkillLevel = 5

		if set_table.S6_QuickenType == 1 then
			BoostSkillTiming = 0
		elseif set_table.S6_QuickenType == 2 then
			BoostSkillTiming = set_table.S6_QuickenEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.S6_QuickenStopSP  = set_table.S6_QuickenStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S6_QuickenStopSP * 0.01

		DebuffSkill = SKILL_DECAGI
		DebuffSkillMaxLevel = 3
		set_table.S6_DecAGIStopSP = set_table.S6_DecAGIStopSP or 5
		DebuffSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S6_DecAGIStopSP * 0.01

	elseif (SWORDMAN07 == type) then
		AttackSkill	= SKILL_BASH
		AttackSkillMaxLevel = 10
		set_table.S7_BashStopSP = set_table.S7_BashStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S7_BashStopSP * 0.01

		BoostSkill	= SKILL_BERSERK
		BoostSkillLevel = 1

		if set_table.S_BerserkType == 1 then
			BoostSkillTiming = 0
		elseif set_table.S_BerserkType == 2 then
			BoostSkillTiming = set_table.S_BerserkEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.S_BerserkStopSP  = set_table.S_BerserkStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S_BerserkStopSP * 0.01

		UseDebuffSkill = function() end

	elseif (SWORDMAN08 == type) then
		AttackSkill	= SKILL_BOWLINGBASH
		AttackSkillMaxLevel = 5
		set_table.S8_BBashStopSP = set_table.S8_BBashStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S8_BBashStopSP * 0.01
		AttackSkillCount = set_table.S8_BBashEnemy or 1
		SplashSkillRadius = 1
		CheckTargetsNum = CheckSplashTargets

		BoostSkill	= SKILL_WEAPON_QUICKEN
		BoostSkillLevel = 10

		if set_table.S8_QuickenType == 1 then
			BoostSkillTiming = 0
		elseif set_table.S8_QuickenType == 2 then
			BoostSkillTiming = set_table.S8_QuickenEnemy or 1
		else
			BoostSkillTiming = -1
		end
		set_table.S8_QuickenStopSP  = set_table.S8_QuickenStopSP or 5
		BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.S8_QuickenStopSP * 0.01

		UseDebuffSkill = function() end

	elseif (SWORDMAN09 <= type and type <= SWORDMAN10) then
		SetAttackSkill = function() end

		if (Cmd_MoveToSide[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[0] = 0
		end
		if (Cmd_MoveToSide[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[1] = 0
		end
		if (Cmd_AltRight[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[0] = 0
		end
		if (Cmd_AltRight[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[1] = 0
		end

		UseDebuffSkill = function() end
		BoostSkillCheck = function() end
	end

	if set_table.MobIDInfo == 1 then
		OnIdleMobID = LoadMobID
	end
end


--    tact    id
function GetTact(id, tact)
	--      
	local type = MobID[id]

	if (tact == "skLvl") then
		--      
		return AttackSkillMaxLevel
	end

	if (type ~= nil and mtact[type] ~= nil and mtact[type]["m_"..tact] ~= nil) then
		return mtact[type]["m_"..tact]
	else
		return mtact[0]["m_"..tact]
	end
end


function LoadMobID()
	local fp = io.open(AI_DIR.."Mob_ID.lua")
	if(fp == nil) then return end

	local line = fp:read()

	while line ~= nil do
		for k,v in string.gfind(line, "MobID[%s]-[[]([%w]+)[]][%s]-=[%s]-([%w]+)") do
			MobID[str2num(k)] = str2num(v)
		end

		line = fp:read()
	end

	fp:close()
end

function CheckSplashTargets()
-------------------------------------------------
--   ,     Magnum Break  Bowling Bash
-------------------------------------------------
	local TargetsNum = 0
	local actors = GetActors()

	for i,v in ipairs(actors) do
		if (v > 0 and IsMonster (v) == 1) then
			local x,y = GetV(V_POSITION,v)
			if (x ~= -1 and GetDistance (MyX,MyY,x,y) <= SplashSkillRadius 
			and MOTION_DEAD ~= GetV(V_MOTION,v)) then
				TargetsNum = TargetsNum + 1
			end
		end
	end

--	TraceAI("Number of targets "..TargetsNum)
	return TargetsNum
end


function CheckBrandishTargets_Aegis (TargetID,Level)
-------------------------------------------------
--   ,    Brandish Spear
-------------------------------------------------
	local tx,ty = GetV(V_POSITION,TargetID)
	local angle = GetAngle(MyX,MyY,tx,ty)

	local spots = {}
	spots[0] = {{a=90,r=1}, {a=-90,r=1}, {a=90,r=2}, {a=-90,r=2}}
	spots[1] = {{a=90,r=1}, {a=-90,r=1}, {a=90,r=2}, {a=-90,r=2}}
	spots[2] = {{a=90,r=1}, {a=-90,r=1}, {a=90,r=2}, {a=-90,r=2}}
	spots[3] = {{a=90,r=1}, {a=-90,r=1}, {a=90,r=2}, {a=-90,r=2}}
	spots[4] = {{a=90,r=1}, {a=-90,r=1}}

	local cells = {}
	local i,v,l

	if (Level <= 3) then 
		l = 1
	elseif (Level <= 6) then 
		l = 2
	elseif (Level <= 9) then 
		l = 3
	else 
		l = 4 
	end
	
	TraceAI ("Brandish start Target="..tx..","..ty.." My="..MyX..","..MyY.." Owner="..OwnerX..","..OwnerY)
	for r = 0,l,1 do
		x,y = PlotCircle (MyX,MyY,angle,r)
		cells[r*5] = {math.floor(x),math.floor(y)}
		TraceAI ("Brandish calc1 "..angle.." "..r.." "..(r*5).." "..cells[r*5][1].." "..cells[r*5][2])

		for i,v in pairs (spots[r]) do
			local zx,zy = PlotCircle (x,y,angle+v.a,v.r)
			cells[r*5+i] = {math.floor(zx),math.floor(zy)}
			TagCell (cells[r*5+i][1],cells[r*5+i][2],9)
			TraceAI ("Brandish calc2 "..v.a.." "..v.r.." "..(r*5+i).." "..cells[r*5+i][1].." "..cells[r*5+i][2])
		end
	end

	LogMap (MAP,MyX,MyY,tx,ty)

	local TargetsNum = 0
	local actors = GetActors()

	for i,v in ipairs(actors) do
		if (v > 0 and IsMonster (v) == 1) then
			local x,y = GetV(V_POSITION,v)
			if (x ~= -1 and MOTION_DEAD ~= GetV(V_MOTION,v)) then
				for k,c in pairs(cells) do
					if (x == c[1] and y == c[2]) then
						TargetsNum = TargetsNum + 1
					end
				end
			end
		end
	end

	TraceAI("Number of targets "..TargetsNum)
	return TargetsNum
end


function BrandishCells (cells,dir,x,y,are)
	if (dir == 0) then
		cells[5*are+1]={x-1,y-1+are}		--
		cells[5*are+2]={x,y-1+are}		--        x  
		cells[5*are+3]={x+1,y-1+are}		--      .....
		if (are < 4) then                       --
			cells[5*are+4]={x-2,y-1+are}	--
			cells[5*are+5]={x+2,y-1+are}
		end

	elseif (dir == 2) then
		cells[5*are+1]={x+1-are,y+1}		--       .
		cells[5*are+2]={x+1-are,y}		--       .
		cells[5*are+3]={x+1-are,y-1}		--      x.
		if (are < 4) then			--	 .
			cells[5*are+4]={x+1-are,y+2}	--       .
			cells[5*are+5]={x+1-are,y-2}
		end

	elseif (dir == 4) then
		cells[5*are+1]={x-1,y+1-are}
		cells[5*are+2]={x,y+1-are}
		cells[5*are+3]={x+1,y+1-are}
		if (are < 4) then
			cells[5*are+4]={x-2,y+1-are}
			cells[5*are+5]={x+2,y+1-are}
		end

	elseif (dir == 6) then
		cells[5*are+1]={x-1+are,y+1}
		cells[5*are+2]={x-1+are,y}
		cells[5*are+3]={x-1+are,y-1}
		if (are < 4) then
			cells[5*are+4]={x-1+are,y+2}
			cells[5*are+5]={x-1+are,y-2}
		end

	elseif (dir == 1) then 				--         .	There's a bug in eAthena
		cells[5*are+1]={x-are,y-3+are}		--      x .	while calculating skill's
		cells[5*are+2]={x+1-are,y-1+are}	--       .	square in this direction
		cells[5*are+3]={x+2-are,y+are}		--		(x1 > x2 and y1 < y2)
		if (are < 4) then			--      .
			cells[5*are+4]={x-1-are,y-4+are}--     .
			cells[5*are+5]={x+3-are,y+1+are}
		end 

	elseif (dir == 3) then
		cells[5*are+1]={x+2-are,y-are}		--     . 
		cells[5*are+2]={x+1-are,y+1-are}	--      . 
		cells[5*are+3]={x-are,y+2-are}		--       .
		if (are < 4) then			--      x .
			cells[5*are+4]={x+3-are,y-1-are}--         . 
			cells[5*are+5]={x-1-are,y+3-are}
		end

	elseif (dir == 5) then
		cells[5*are+1]={x+are,y+2-are}
		cells[5*are+2]={x-1+are,y+1-are}
		cells[5*are+3]={x-2+are,y-are}
		if (are < 4) then
			cells[5*are+4]={x+1+are,y+3-are}
			cells[5*are+5]={x-3+are,y-1-are}
		end

	elseif (dir == 7) then
		cells[5*are+1]={x-2+are,y+are}		--        .
		cells[5*are+2]={x-1+are,y-1+are}	--         . x
		cells[5*are+3]={x+are,y-2+are}		--          .
		if (are < 4) then			--           .
			cells[5*are+4]={x-3+are,y+1+are}--            .
			cells[5*are+5]={x+1+are,y-3+are}
		end
	end
end

function CheckBrandishTargets_eAthena (TargetID,Level)
-------------------------------------------------
--   ,    Brandish Spear
-------------------------------------------------
	local tx,ty = GetV(V_POSITION,TargetID)
	local dir = CalcDirection(tx,ty,MyX,MyY)
	local cells = {}

	TraceAI ("Brandish level "..Level)

	BrandishCells (cells,dir,tx,ty,0)
	BrandishCells (cells,dir,tx,ty,1)
	if (Level > 3) then
		BrandishCells (cells,dir,tx,ty,2)
	end
	if (Level > 6) then
		BrandishCells (cells,dir,tx,ty,3)
	end
	if (Level > 9) then
		BrandishCells (cells,dir,tx,ty,4)
	end

	local TargetsNum = 0
	local actors = GetActors()

	for i,v in ipairs(actors) do
		if (v > 0 and IsMonster (v) == 1) then
			local x,y = GetV(V_POSITION,v)
			if (x ~= -1 and MOTION_DEAD ~= GetV(V_MOTION,v)) then
				for k,c in pairs(cells) do
					if (x == c[1] and y == c[2]) then
						TargetsNum = TargetsNum + 1
					end
				end
			end
		end
	end

	TraceAI("Number of targets "..TargetsNum)
	return TargetsNum
end
